function InitializeBuffListener()
	buff_list.EffectAdded = function(sender, args)
		if SetContains(bonus_buffs, buff_list:Get(args.Index):GetName()) then
			UpdateBonus()
			UpdateKeeps()
			UpdateOutposts()
		end
	end

	buff_list.EffectRemoved = function(sender, args)
		if SetContains(bonus_buffs, args.Effect:GetName()) then
			UpdateBonus()
			UpdateKeeps()
			UpdateOutposts()
		end
	end

	UpdateBonus()
	UpdateKeeps()
	UpdateOutposts()
end

function UpdateBonus()
	local bonus = 0

	local treeOwned = false
	local drakeOwned = false
	local garyOwned = false

	local crownOwned = false
	local carrockOwned = false

	local outnumbered = false

	for i = 1, buff_list:GetCount() do
		local element = buff_list:Get(i):GetName()
		if SetContains(bonus_buffs, element) then
			bonus = bonus + bonus_buffs[element]

			-- DoF buffs
			if element == dof_buffs[1] then
				if OverviewWindow:IsTreeOwned() == false then
					OverviewWindow:ResetTreeTimer()
				end
				OverviewWindow:SetTreeOwner(true)
				treeOwned = true
			elseif element == dof_buffs[2] then
				if OverviewWindow:IsDrakeOwned() == false then
					OverviewWindow:ResetDrakeTimer()
				end
				OverviewWindow:SetDrakeOwner(true)
				drakeOwned = true
			elseif element == dof_buffs[3] then
				if OverviewWindow:IsGaryOwned() == false then
					OverviewWindow:ResetGaryTimer()
				end
				OverviewWindow:SetGaryOwner(true)
				garyOwned = true
			end

			-- Relic buffs
			if Turbine.Gameplay.LocalPlayer.GetInstance():GetAlignment() == Turbine.Gameplay.Alignment.MonsterPlayer then
				if element == relic_buffs[1] then
					if OverviewWindow:IsCrownOwned() == false then
						OverviewWindow:ResetCrownTimer()
					end
					OverviewWindow:SetCrownOwner(true)
					crownOwned = true
				end
				if (element == relic_buffs[2] or element == relic_buffs[3]) then
					if OverviewWindow:IsCarrockOwned() == false then
						OverviewWindow:ResetCarrockTimer()
					end
					OverviewWindow:SetCarrockOwner(true)
					carrockOwned = true
				end
			else
				if element == relic_buffs[4] then
					if OverviewWindow:IsCarrockOwned() == false then
						OverviewWindow:ResetCarrockTimer()
					end
					OverviewWindow:SetCarrockOwner(true)
					carrockOwned = true
				end
				if (element == relic_buffs[5] or element == relic_buffs[6]) then
					if OverviewWindow:IsCrownOwned() == false then
						OverviewWindow:ResetCrownTimer()
					end
					OverviewWindow:SetCrownOwner(true)
					crownOwned = true
				end
			end

			-- Outnumbered buffs
			if (element == outnumbered_buffs[1] or element == outnumbered_buffs[2]) then
				if OverviewWindow:IsOutnumberedOwned() == false then
					OverviewWindow:ResetOutnumberedTimer()
				end
				OverviewWindow:SetOutnumberedOwner(true)
				outnumbered = true
			end
		end
	end

	-- Reset DoF buff owners
	if treeOwned == false then
		if OverviewWindow:IsTreeOwned() == true then
			OverviewWindow:ResetTreeTimer()
		end
		OverviewWindow:SetTreeOwner(false)
	end

	if drakeOwned == false then
		if OverviewWindow:IsDrakeOwned() == true then
			OverviewWindow:ResetDrakeTimer()
		end
		OverviewWindow:SetDrakeOwner(false)
	end

	if garyOwned == false then
		if OverviewWindow:IsGaryOwned() == true then
			OverviewWindow:ResetGaryTimer()
		end
		OverviewWindow:SetGaryOwner(false)
	end

	-- Reset Relic buff owners
	if crownOwned == false then
		if OverviewWindow:IsCrownOwned() == true then
			OverviewWindow:ResetCrownTimer()
		end
		OverviewWindow:SetCrownOwner(false)
	end

	if carrockOwned == false then
		if OverviewWindow:IsCarrockOwned() == true then
			OverviewWindow:ResetCarrockTimer()
		end
		OverviewWindow:SetCarrockOwner(false)
	end

	-- Reset Outnumbered buff owners
	if outnumbered == false then
		if OverviewWindow:IsOutnumberedOwned() == true then
			OverviewWindow:ResetOutnumberedTimer()
		end
		OverviewWindow:SetOutnumberedOwner(false)
	end

	OverviewWindow.label_bonus:SetText(L.BuffWatcher_Bonus .. bonus .. "%")
	MapWindow:UpdateKeepsOnMap()
end

function UpdateOutposts()
	local alignedOutposts = 0
	local enemyOutposts = 0
	local alignedOutpostsList = {}
	local enemyOutpostsList = {}

	for key, value in pairs(outposts_acr) do
		enemyOutposts = enemyOutposts + 1
		enemyOutpostsList[enemyOutposts] = value
	end

	for i = 1, buff_list:GetCount() do
		local element = buff_list:Get(i):GetName()
		if SetContains(outposts_acr, element) then
			alignedOutpostsList[alignedOutposts] = outposts_acr[element]
			table.remove(enemyOutpostsList, FindIndex(enemyOutpostsList, outposts_acr[element]))
			alignedOutposts = alignedOutposts + 1
		end
	end

	-- Set all outposts bar colors to EnemyColor
	OverviewWindow.outpost1:SetBackColor(EnemyColor)
	OverviewWindow.outpost2:SetBackColor(EnemyColor)
	OverviewWindow.outpost3:SetBackColor(EnemyColor)
	OverviewWindow.outpost4:SetBackColor(EnemyColor)

	if alignedOutposts == 0 then
		OverviewWindow.outpost1Text:SetText(enemyOutpostsList[1])
		OverviewWindow.outpost2Text:SetText(enemyOutpostsList[2])
		OverviewWindow.outpost3Text:SetText(enemyOutpostsList[3])
		OverviewWindow.outpost4Text:SetText(enemyOutpostsList[4])
	end
	if alignedOutposts >= 1 then
		OverviewWindow.outpost1:SetBackColor(AlignedColor)
		OverviewWindow.outpost1Text:SetText(alignedOutpostsList[0])

		OverviewWindow.outpost2Text:SetText(enemyOutpostsList[1])
		OverviewWindow.outpost3Text:SetText(enemyOutpostsList[2])
		OverviewWindow.outpost4Text:SetText(enemyOutpostsList[3])
	end
	if alignedOutposts >= 2 then
		OverviewWindow.outpost2:SetBackColor(AlignedColor)
		OverviewWindow.outpost2Text:SetText(alignedOutpostsList[1])

		OverviewWindow.outpost3Text:SetText(enemyOutpostsList[1])
		OverviewWindow.outpost4Text:SetText(enemyOutpostsList[2])
	end
	if alignedOutposts >= 3 then
		OverviewWindow.outpost3:SetBackColor(AlignedColor)
		OverviewWindow.outpost3Text:SetText(alignedOutpostsList[2])

		OverviewWindow.outpost4Text:SetText(enemyOutpostsList[1])
	end
	if alignedOutposts == 4 then
		OverviewWindow.outpost4:SetBackColor(AlignedColor)
		OverviewWindow.outpost4Text:SetText(alignedOutpostsList[3])
	end
	MapWindow:UpdateKeepsOnMap()
end

function UpdateKeeps()
	local found = false
	local fCount = 0
	local cCount = 0

	--Set all freep keeps to invisible and empty text
	OverviewWindow.fKeep1:SetVisible(false)
	OverviewWindow.fKeep1Text:SetText("")
	OverviewWindow.fKeep2:SetVisible(false)
	OverviewWindow.fKeep2Text:SetText("")
	OverviewWindow.fKeep3:SetVisible(false)
	OverviewWindow.fKeep3Text:SetText("")
	OverviewWindow.fKeep4:SetVisible(false)
	OverviewWindow.fKeep4Text:SetText("")
	OverviewWindow.fKeep5:SetVisible(false)
	OverviewWindow.fKeep5Text:SetText("")

	--Set all creep keeps to invisible and empty text
	OverviewWindow.cKeep1:SetVisible(false)
	OverviewWindow.cKeep1Text:SetText("")
	OverviewWindow.cKeep2:SetVisible(false)
	OverviewWindow.cKeep2Text:SetText("")
	OverviewWindow.cKeep3:SetVisible(false)
	OverviewWindow.cKeep3Text:SetText("")
	OverviewWindow.cKeep4:SetVisible(false)
	OverviewWindow.cKeep4Text:SetText("")
	OverviewWindow.cKeep5:SetVisible(false)
	OverviewWindow.cKeep5Text:SetText("")

	for i = 1, 5 do
		local element = rkeeps[i]
		found = false
		if Turbine.Gameplay.LocalPlayer.GetInstance():GetAlignment() ~= Turbine.Gameplay.Alignment.MonsterPlayer then
			for j = 1, buff_list:GetCount() do
				local buff_elem = buff_list:Get(j):GetName()
				if element == buff_elem then
					if fCount == 0 then
						OverviewWindow.fKeep1:SetVisible(true)
						OverviewWindow.fKeep1Text:SetText(keeps_acr[element])
					elseif fCount == 1 then
						OverviewWindow.fKeep2:SetVisible(true)
						OverviewWindow.fKeep2Text:SetText(keeps_acr[element])
					elseif fCount == 2 then
						OverviewWindow.fKeep3:SetVisible(true)
						OverviewWindow.fKeep3Text:SetText(keeps_acr[element])
					elseif fCount == 3 then
						OverviewWindow.fKeep4:SetVisible(true)
						OverviewWindow.fKeep4Text:SetText(keeps_acr[element])
					elseif fCount == 4 then
						OverviewWindow.fKeep5:SetVisible(true)
						OverviewWindow.fKeep5Text:SetText(keeps_acr[element])
					end
					fCount = fCount + 1
					found = true
					j = buff_list:GetCount()
				end
			end
			if not found then
				if cCount == 0 then
					OverviewWindow.cKeep1:SetVisible(true)
					OverviewWindow.cKeep1Text:SetText(keeps_acr[element])
				elseif cCount == 1 then
					OverviewWindow.cKeep2:SetVisible(true)
					OverviewWindow.cKeep2Text:SetText(keeps_acr[element])
				elseif cCount == 2 then
					OverviewWindow.cKeep3:SetVisible(true)
					OverviewWindow.cKeep3Text:SetText(keeps_acr[element])
				elseif cCount == 3 then
					OverviewWindow.cKeep4:SetVisible(true)
					OverviewWindow.cKeep4Text:SetText(keeps_acr[element])
				elseif cCount == 4 then
					OverviewWindow.cKeep5:SetVisible(true)
					OverviewWindow.cKeep5Text:SetText(keeps_acr[element])
				end
				cCount = cCount + 1
			end
		else
			for j = 1, buff_list:GetCount() do
				local buff_elem = buff_list:Get(j):GetName()
				if element == buff_elem then
					if cCount == 0 then
						OverviewWindow.cKeep1:SetVisible(true)
						OverviewWindow.cKeep1Text:SetText(keeps_acr[element])
					elseif cCount == 1 then
						OverviewWindow.cKeep2:SetVisible(true)
						OverviewWindow.cKeep2Text:SetText(keeps_acr[element])
					elseif cCount == 2 then
						OverviewWindow.cKeep3:SetVisible(true)
						OverviewWindow.cKeep3Text:SetText(keeps_acr[element])
					elseif cCount == 3 then
						OverviewWindow.cKeep4:SetVisible(true)
						OverviewWindow.cKeep4Text:SetText(keeps_acr[element])
					elseif cCount == 4 then
						OverviewWindow.cKeep5:SetVisible(true)
						OverviewWindow.cKeep5Text:SetText(keeps_acr[element])
					end
					cCount = cCount + 1
					found = true
					j = buff_list:GetCount()
				end
			end
			if not found then
				if fCount == 0 then
					OverviewWindow.fKeep1:SetVisible(true)
					OverviewWindow.fKeep1Text:SetText(keeps_acr[element])
				elseif fCount == 1 then
					OverviewWindow.fKeep2:SetVisible(true)
					OverviewWindow.fKeep2Text:SetText(keeps_acr[element])
				elseif fCount == 2 then
					OverviewWindow.fKeep3:SetVisible(true)
					OverviewWindow.fKeep3Text:SetText(keeps_acr[element])
				elseif fCount == 3 then
					OverviewWindow.fKeep4:SetVisible(true)
					OverviewWindow.fKeep4Text:SetText(keeps_acr[element])
				elseif fCount == 4 then
					OverviewWindow.fKeep5:SetVisible(true)
					OverviewWindow.fKeep5Text:SetText(keeps_acr[element])
				end
				fCount = fCount + 1
			end
		end
	end
	MapWindow:UpdateKeepsOnMap()
end

function FindIndex(tbl, val)
	for index, value in pairs(tbl) do
		if value == val then
			return index
		end
	end
end

function SetContains(set, key)
	return set[key]
end