HitWindow = class(Turbine.UI.Window)

function HitWindow:Constructor()
	HitWidth = 110
	HitHeight = 245

	Turbine.UI.Window.Constructor(self)

	self:SetSize(HitWidth, HitHeight)
	self:SetPosition(data.numbers.hitWin_x, data.numbers.hitWin_y)
	self:SetBackColor(Turbine.UI.Color.Black)
	self:SetMouseVisible(false)
	self:SetOpacity(0.9)

	self.DragBar = DragBar(self, "PvMP+ Hit Window")

	self.panel = Turbine.UI.Control()
	self.panel:SetParent(self)
	self.panel:SetSize(HitWidth, HitHeight)
	self.panel:SetTop(0)
	self.panel:SetBackColor(Turbine.UI.Color.Black)
	self.panel:SetMouseVisible(false)

	self.amount_label = Turbine.UI.Label()
	self.amount_label:SetParent(self.panel)
	self.amount_label:SetSize(55, 20)
	self.amount_label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
	self.amount_label:SetPosition(5, 5)
	self.amount_label:SetForeColor(default_font_color)
	self.amount_label:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.amount_label:SetText(L.Amount)
	self.amount_label:SetMouseVisible(false)

	self.amount_box = Turbine.UI.Lotro.TextBox()
	self.amount_box:SetParent(self.panel)
	self.amount_box:SetSize(25, 20)
	self.amount_box:SetPosition(self.amount_label:GetWidth() - 5, 5)
	self.amount_box:SetForeColor(default_font_color)
	self.amount_box:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.amount_box:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.amount_box:SetMultiline(false)
	self.amount_box:SetReadOnly(true)
	self.amount_box:SetText("0")

	self.hitLocContainer = Turbine.UI.Control()
	self.hitLocContainer:SetParent(self.panel)
	self.hitLocContainer:SetSize(25, 20)
	self.hitLocContainer:SetPosition(self:GetWidth() - self.hitLocContainer:GetWidth() - 5, 5)

	self.hitSendQS = Turbine.UI.Lotro.Quickslot()
	self.hitSendQS:SetParent(self.hitLocContainer)
	self.hitSendQS:SetSize(self.hitLocContainer:GetSize())
	self.hitSendQS:SetUseOnRightClick(false)
	self.hitSendQS:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, ""))
	self.hitSendQS.MouseDown = function(sender, args)
		if args.Button == Turbine.UI.MouseButton.Right then
			self.contextMenu:ShowMenu()
		end
	end

	self.hitListOverlayBack = Turbine.UI.Control()
	self.hitListOverlayBack:SetParent(self.hitLocContainer)
	self.hitListOverlayBack:SetSize(self.hitLocContainer:GetSize())
	self.hitListOverlayBack:SetBackColor(default_font_color)
	self.hitListOverlayBack:SetMouseVisible(false)

	self.hitListOverlay = Turbine.UI.Label()
	self.hitListOverlay:SetParent(self.hitLocContainer)
	self.hitListOverlay:SetSize(self.hitLocContainer:GetWidth() - 2, self.hitLocContainer:GetHeight() - 2)
	self.hitListOverlay:SetPosition(1, 1)
	self.hitListOverlay:SetFont(Turbine.UI.Lotro.Font.Verdana10)
	self.hitListOverlay:SetBackColor(Turbine.UI.Color.Black)
	self.hitListOverlay:SetForeColor(default_font_color)
	self.hitListOverlay:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.hitListOverlay:SetText(L.Send)
	self.hitListOverlay:SetMouseVisible(false)

	self.contextMenu = Turbine.UI.ContextMenu()
	if data.numbers.selectedChannel3 == nil then
		data.numbers.selectedChannel3 = 5
	end

	for i = 2, #L.ChatChannels - 4 do
		self:AddChatChannel(L.ChatChannels[i][2])
	end

	self.recent_hits_panel = Turbine.UI.Control()
	self.recent_hits_panel:SetParent(self.panel)
	self.recent_hits_panel:SetSize(self.panel:GetWidth() - 10, self.panel:GetHeight() - 60)
	self.recent_hits_panel:SetBackColor(default_font_color)
	self.recent_hits_panel:SetMouseVisible(false)
	self.recent_hits_panel:SetPosition(5, 32)

	self.recent_hits_label = Turbine.UI.Label()
	self.recent_hits_label:SetParent(self.recent_hits_panel)
	self.recent_hits_label:SetSize(self.recent_hits_panel:GetWidth() - 2, 20)
	self.recent_hits_label:SetPosition(1, 1)
	self.recent_hits_label:SetBackColor(Turbine.UI.Color.Black)
	self.recent_hits_label:SetForeColor(default_font_color)
	self.recent_hits_label:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
	self.recent_hits_label:SetFontStyle(Turbine.UI.FontStyle.Outline)
	self.recent_hits_label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.recent_hits_label:SetText(L.RecentHits)
	self.recent_hits_label:SetMouseVisible(false)

	self.recent_hits = Turbine.UI.ListBox()
	self.recent_hits:SetParent(self.recent_hits_panel)
	self.recent_hits:SetSize(self.recent_hits_panel:GetWidth() - 2, self.recent_hits_panel:GetHeight() - 22)
	self.recent_hits:SetPosition(1, 21)
	self.recent_hits:SetBackColor(Turbine.UI.Color(48 / 255, 48 / 255, 48 / 255))
	self.recent_hits.maxEntries = 12
	self.recent_hits:SetMouseVisible(false)

	self.link_hits_checkbox = Turbine.UI.Lotro.CheckBox()
	self.link_hits_checkbox:SetParent(self.panel)
	self.link_hits_checkbox:SetText(L.Link_Count)
	self.link_hits_checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.link_hits_checkbox:SetForeColor(default_font_color)
	self.link_hits_checkbox:SetSize(HitWidth - 10, 16)
	self.link_hits_checkbox:SetPosition(
		(HitWidth - self.link_hits_checkbox:GetWidth()) / 2,
		self.recent_hits_panel:GetTop() + self.recent_hits_panel:GetHeight() + 5
	)
	self.link_hits_checkbox:SetChecked(not storage.link_counts_disabled)

	self.link_hits_checkbox.CheckedChanged = function()
		storage.link_counts_disabled = not storage.link_counts_disabled
	end

	self.VisibleChanged = function(sender)
		if not sender:IsVisible() then
			self:SetVisible(false)
		end
	end

	self.PositionChanged = function(sender, args)
		data.numbers.hitWin_x = self:GetLeft()
		data.numbers.hitWin_y = self:GetTop()
	end

	self:SetVisible(not storage.show_recent_hits_disabled)
	self:UpdateChatData()
end

function HitWindow:NewRecentHit(name)
	hitList[name] = hitCount + 1
	hitListRvr[hitCount + 1] = name
	hitCount = hitCount + 1

	self.amount_box:SetText(hitCount)

	if self.link_hits_checkbox:IsChecked() then
		SecondaryWindow:UpdateCount(hitCount)
	end

	if self.recent_hits:GetItemCount() == self.recent_hits.maxEntries then
		self.recent_hits:RemoveItemAt(self.recent_hits:GetItemCount())
	end

	local listItem = self:GetRecentHitListItem(name)
	self.recent_hits:InsertItem(1, listItem)
	self:UpdateChatData()
end

function HitWindow:GetRecentHitListItem(name)
	local item = Turbine.UI.Label()
	item:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	item:SetSize(self.recent_hits:GetWidth(), self.recent_hits:GetHeight() / self.recent_hits.maxEntries)
	item:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	item:SetMouseVisible(false)
	item:SetText(name)
	return item
end

function HitWindow:ClearHitList()
	self.amount_box:SetText("0")
	self.recent_hits:ClearItems()
	if self.link_hits_checkbox:IsChecked() then
		SecondaryWindow:UpdateCount(hitCount)
	end
end

function HitWindow:UpdateChatData()
	local text = "/" .. L.ChatChannels[data.numbers.selectedChannel3][1] .. " <rgb=" .. hitChatColor .. ">"
	local sc = self.hitSendQS:GetShortcut()

	for ii = 1, hitCount do
		text = text .. hitListRvr[ii]
		if ii < hitCount then
			text = text .. ", "
		end
	end

	text = text .. "</rgb>"
	sc:SetData(text)
	self.hitSendQS:SetShortcut(sc)
	self.hitSendQS:SetAllowDrop(false)
end

function HitWindow:ShowRecentHits(show)
	if show then
		self:SetHeight(HitHeight)
		self.panel:SetHeight(HitHeight - 20)
		self.recent_hits_panel:SetVisible(true)
	else
		self:SetHeight(HitHeight - self.recent_hits_panel:GetHeight() - 5)
		self.panel:SetHeight(HitHeight - 20 - self.recent_hits_panel:GetHeight() - 5)
		self.recent_hits_panel:SetVisible(false)
	end
end

function HitWindow:AddChatChannel(channelname, isUserChannel)
	local index = self.contextMenu:GetItems():GetCount() + 1
	if isUserChannel then
		for i = 1, 4 do
			if usedUserChannels[i] == nil then
				index = 4 + i
				break
			end
		end
	end

	local menuItem = Turbine.UI.MenuItem(channelname, true, data.numbers.selectedChannel3 == index + 1)
	menuItem.Click = function(sender)
		for j = 1, self.contextMenu:GetItems():GetCount() do
			self.contextMenu:GetItems():Get(j):SetChecked(false)
		end
		sender:SetChecked(true)
		data.numbers.selectedChannel3 = index + 1
		self:UpdateChatData()
	end
	self.contextMenu:GetItems():Insert(index, menuItem)
end

function HitWindow:RemoveChatChannel(channelname)
	local contextMenuItemList = self.contextMenu:GetItems()
	for j = 1, contextMenuItemList:GetCount() do
		if string.lower(contextMenuItemList:Get(j):GetText()) == string.lower(channelname) then
			for i = 1, 4 do
				if usedUserChannels[i] == string.lower(channelname) then
					usedUserChannels[i] = nil
					break
				end
			end
			contextMenuItemList:RemoveAt(j)
			return
		end
	end
end