Settings = class(Turbine.UI.Window)

function Settings:Constructor()
	local width = 410
	local height = 490

	Turbine.UI.Lotro.Window.Constructor(self)

	self:SetSize(width, height)
	self:SetPosition(data.numbers.settingsWin_x, data.numbers.settingsWin_y)
	self:SetZOrder(1)
	self:SetText(L.Options_Header)
	self:SetWantsKeyEvents(true)

	-- Data Settings
	self.infamyRenownSettings = Turbine.UI.Label()
	self.infamyRenownSettings:SetParent(self)
	self.infamyRenownSettings:SetSize(width - 40, 20)
	self.infamyRenownSettings:SetPosition(width / 2 - self.infamyRenownSettings:GetWidth() / 2, 35)
	self.infamyRenownSettings:SetForeColor(default_font_color)
	self.infamyRenownSettings:SetFont(Turbine.UI.Lotro.Font.TrajanPro18)
	self.infamyRenownSettings:SetFontStyle(Turbine.UI.FontStyle.Outline)
	self.infamyRenownSettings:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.infamyRenownSettings:SetText(L.Options_Data_Settings)

	self.points_update_button = Turbine.UI.Lotro.Button()
	self.points_update_button:SetText(L.Options_Update_Points)
	self.points_update_button:SetWidth(width - 235)
	self.points_update_button:SetPosition(
		width / 2 - self.points_update_button:GetWidth() - 15,
		self.infamyRenownSettings:GetTop() + 25
	)
	self.points_update_button:SetParent(self)

	self.frags_update_button = Turbine.UI.Lotro.Button()
	self.frags_update_button:SetText(L.Options_Update_Frags)
	self.frags_update_button:SetWidth(width - 235)
	self.frags_update_button:SetPosition(width / 2 + 5, self.infamyRenownSettings:GetTop() + 25)
	self.frags_update_button:SetParent(self)

	-- Display Settings
	self.displaySettings = Turbine.UI.Label()
	self.displaySettings:SetParent(self)
	self.displaySettings:SetSize(width - 40, 20)
	self.displaySettings:SetPosition(
		width / 2 - self.displaySettings:GetWidth() / 2,
		self.points_update_button:GetTop() + 30
	)
	self.displaySettings:SetForeColor(default_font_color)
	self.displaySettings:SetFont(Turbine.UI.Lotro.Font.TrajanPro18)
	self.displaySettings:SetFontStyle(Turbine.UI.FontStyle.Outline)
	self.displaySettings:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.displaySettings:SetText(L.Options_Display_Settings)

	self.show_stats_checkbox = Turbine.UI.Lotro.CheckBox()
	self.show_stats_checkbox:SetParent(self)
	self.show_stats_checkbox:SetText(" " .. L.Options_Show_Stats)
	self.show_stats_checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.show_stats_checkbox:SetForeColor(default_font_color)
	self.show_stats_checkbox:SetSize(width / 2 - 20, 16)
	self.show_stats_checkbox:SetPosition(
		width / 2 - self.show_stats_checkbox:GetWidth(),
		self.displaySettings:GetTop() + 25
	)
	self.show_stats_checkbox:SetChecked(not storage.stats_hidden)

	self.bonus_checkbox = Turbine.UI.Lotro.CheckBox()
	self.bonus_checkbox:SetParent(self)
	self.bonus_checkbox:SetText(" " .. L.Options_Bonus)
	self.bonus_checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.bonus_checkbox:SetForeColor(default_font_color)
	self.bonus_checkbox:SetSize(width - 40, 16)
	self.bonus_checkbox:SetPosition(width / 2 + 5, self.displaySettings:GetTop() + 25)
	self.bonus_checkbox:SetChecked(not storage.show_bonus_disabled)

	self.outpost_checkbox = Turbine.UI.Lotro.CheckBox()
	self.outpost_checkbox:SetParent(self)
	self.outpost_checkbox:SetText(" " .. L.Options_OPs)
	self.outpost_checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.outpost_checkbox:SetForeColor(default_font_color)
	self.outpost_checkbox:SetSize(width / 2 - 20, 16)
	self.outpost_checkbox:SetPosition(width / 2 - self.outpost_checkbox:GetWidth(), self.show_stats_checkbox:GetTop() + 25)
	self.outpost_checkbox:SetChecked(not storage.show_outpost_disabled)

	self.keep_checkbox = Turbine.UI.Lotro.CheckBox()
	self.keep_checkbox:SetEnabled(false)
	self.keep_checkbox:SetParent(self)
	self.keep_checkbox:SetText(" " .. L.Options_Keeps)
	self.keep_checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.keep_checkbox:SetForeColor(temp_disabled_color)
	self.keep_checkbox:SetSize(width - 40, 16)
	self.keep_checkbox:SetPosition(width / 2 + 5, self.bonus_checkbox:GetTop() + 25)
	self.keep_checkbox:SetChecked(not storage.show_keep_disabled)

	self.dof_checkbox = Turbine.UI.Lotro.CheckBox()
	self.dof_checkbox:SetEnabled(false)
	self.dof_checkbox:SetParent(self)
	self.dof_checkbox:SetText(" " .. L.Options_DOF)
	self.dof_checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.dof_checkbox:SetForeColor(temp_disabled_color)
	self.dof_checkbox:SetSize(width / 2 - 20, 16)
	self.dof_checkbox:SetPosition(width / 2 - self.dof_checkbox:GetWidth(), self.outpost_checkbox:GetTop() + 25)
	self.dof_checkbox:SetChecked(not storage.show_dof_disabled)

	self.relic_checkbox = Turbine.UI.Lotro.CheckBox()
	self.relic_checkbox:SetEnabled(false)
	self.relic_checkbox:SetParent(self)
	self.relic_checkbox:SetText(" " .. L.Options_Relic)
	self.relic_checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.relic_checkbox:SetForeColor(temp_disabled_color)
	self.relic_checkbox:SetSize(width - 40, 16)
	self.relic_checkbox:SetPosition(width / 2 + 5, self.keep_checkbox:GetTop() + 25)
	self.relic_checkbox:SetChecked(not storage.show_relic_disabled)

	self.on_checkbox = Turbine.UI.Lotro.CheckBox()
	self.on_checkbox:SetEnabled(false)
	self.on_checkbox:SetParent(self)
	self.on_checkbox:SetText(" " .. L.Options_ON)
	self.on_checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.on_checkbox:SetForeColor(temp_disabled_color)
	self.on_checkbox:SetSize(width / 2 - 20, 16)
	self.on_checkbox:SetPosition(width / 2 - self.on_checkbox:GetWidth(), self.dof_checkbox:GetTop() + 25)
	self.on_checkbox:SetChecked(not storage.show_on_disabled)

	-- Alert Settings
	self.alertSettings = Turbine.UI.Label()
	self.alertSettings:SetParent(self)
	self.alertSettings:SetSize(width - 40, 20)
	self.alertSettings:SetPosition(width / 2 - self.alertSettings:GetWidth() / 2, self.on_checkbox:GetTop() + 27)
	self.alertSettings:SetForeColor(default_font_color)
	self.alertSettings:SetFont(Turbine.UI.Lotro.Font.TrajanPro18)
	self.alertSettings:SetFontStyle(Turbine.UI.FontStyle.Outline)
	self.alertSettings:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.alertSettings:SetText(L.Options_Alert_Settings)

	self.track_warning_checkbox = Turbine.UI.Lotro.CheckBox()
	self.track_warning_checkbox:SetParent(self)
	self.track_warning_checkbox:SetText(" " .. L.Options_Track_Warning)
	self.track_warning_checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.track_warning_checkbox:SetForeColor(default_font_color)
	self.track_warning_checkbox:SetSize(width / 2 - 20, 16)
	self.track_warning_checkbox:SetPosition(
		width / 2 - self.track_warning_checkbox:GetWidth(),
		self.alertSettings:GetTop() + 25
	)
	self.track_warning_checkbox:SetChecked(not storage.track_warning_disabled)

	self.stealth_alert_checkbox = Turbine.UI.Lotro.CheckBox()
	self.stealth_alert_checkbox:SetParent(self)
	self.stealth_alert_checkbox:SetText(" " .. L.Options_StealthAlert)
	self.stealth_alert_checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.stealth_alert_checkbox:SetForeColor(default_font_color)
	self.stealth_alert_checkbox:SetSize(width / 2 - 20, 16)
	self.stealth_alert_checkbox:SetPosition(width / 2 + 5, self.alertSettings:GetTop() + 25)
	self.stealth_alert_checkbox:SetChecked(not storage.stealth_alert_disabled)

	self.yourfrag_alert_checkbox = Turbine.UI.Lotro.CheckBox()
	self.yourfrag_alert_checkbox:SetParent(self)
	self.yourfrag_alert_checkbox:SetText(" " .. L.Options_YourFragAlert)
	self.yourfrag_alert_checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.yourfrag_alert_checkbox:SetForeColor(default_font_color)
	self.yourfrag_alert_checkbox:SetSize(width / 2 - 20, 16)
	self.yourfrag_alert_checkbox:SetPosition(
		width / 2 - self.yourfrag_alert_checkbox:GetWidth(),
		self.track_warning_checkbox:GetTop() + 25
	)
	self.yourfrag_alert_checkbox:SetChecked(not storage.yourfrag_alert_disabled)

	self.lootbox_alert_checkbox = Turbine.UI.Lotro.CheckBox()
	self.lootbox_alert_checkbox:SetParent(self)
	self.lootbox_alert_checkbox:SetText(" " .. L.Options_LootboxAlert)
	self.lootbox_alert_checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.lootbox_alert_checkbox:SetForeColor(default_font_color)
	self.lootbox_alert_checkbox:SetSize(width / 2 - 20, 16)
	self.lootbox_alert_checkbox:SetPosition(width / 2 + 5, self.track_warning_checkbox:GetTop() + 25)
	self.lootbox_alert_checkbox:SetChecked(not storage.lootbox_alert_disabled)

	self.comms_warning_checkbox = Turbine.UI.Lotro.CheckBox()
	self.comms_warning_checkbox:SetParent(self)
	self.comms_warning_checkbox:SetText(" " .. L.Options_Commendation_Warning)
	self.comms_warning_checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.comms_warning_checkbox:SetForeColor(default_font_color)
	self.comms_warning_checkbox:SetSize(width - 40, 16)
	self.comms_warning_checkbox:SetPosition(
		width / 2 - self.comms_warning_checkbox:GetWidth() / 2,
		self.yourfrag_alert_checkbox:GetTop() + 25
	)
	self.comms_warning_checkbox:SetChecked(not storage.comms_warning_disabled)

	self.battletask_warning_checkbox = Turbine.UI.Lotro.CheckBox()
	self.battletask_warning_checkbox:SetParent(self)
	self.battletask_warning_checkbox:SetText(" " .. L.Options_Battle_Task_Warning)
	self.battletask_warning_checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.battletask_warning_checkbox:SetForeColor(default_font_color)
	self.battletask_warning_checkbox:SetSize(width / 2 - 20, 16)
	self.battletask_warning_checkbox:SetPosition(width / 2 + 5, self.lootbox_alert_checkbox:GetTop() + 25)
	self.battletask_warning_checkbox:SetChecked(not storage.battletask_warning_disabled)

	-- Secondary Windows
	self.otherWindowsSettings = Turbine.UI.Label()
	self.otherWindowsSettings:SetParent(self)
	self.otherWindowsSettings:SetSize(width - 40, 20)
	self.otherWindowsSettings:SetPosition(
		width / 2 - self.otherWindowsSettings:GetWidth() / 2,
		self.comms_warning_checkbox:GetTop() + 27
	)
	self.otherWindowsSettings:SetForeColor(default_font_color)
	self.otherWindowsSettings:SetFont(Turbine.UI.Lotro.Font.TrajanPro18)
	self.otherWindowsSettings:SetFontStyle(Turbine.UI.FontStyle.Outline)
	self.otherWindowsSettings:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.otherWindowsSettings:SetText(L.Options_Other_Windows_Settings)

	self.recent_kills_checkbox = Turbine.UI.Lotro.CheckBox()
	self.recent_kills_checkbox:SetParent(self)
	self.recent_kills_checkbox:SetText(" " .. L.Options_Recent_Kills)
	self.recent_kills_checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.recent_kills_checkbox:SetForeColor(default_font_color)
	self.recent_kills_checkbox:SetSize(width / 2 - 20, 16)
	self.recent_kills_checkbox:SetPosition(
		width / 2 - self.recent_kills_checkbox:GetWidth(),
		self.otherWindowsSettings:GetTop() + 25
	)
	self.recent_kills_checkbox:SetChecked(not storage.show_recent_kills_disabled)

	self.recent_hits_checkbox = Turbine.UI.Lotro.CheckBox()
	self.recent_hits_checkbox:SetParent(self)
	self.recent_hits_checkbox:SetText(" " .. L.Options_Recent_Hits)
	self.recent_hits_checkbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.recent_hits_checkbox:SetForeColor(default_font_color)
	self.recent_hits_checkbox:SetSize(width / 2 - 20, 16)
	self.recent_hits_checkbox:SetPosition(width / 2 + 5, self.otherWindowsSettings:GetTop() + 25)
	self.recent_hits_checkbox:SetChecked(not storage.show_recent_hits_disabled)

	-- Other Settings
	self.otherSettings = Turbine.UI.Label()
	self.otherSettings:SetParent(self)
	self.otherSettings:SetSize(width - 40, 20)
	self.otherSettings:SetPosition(width / 2 - self.otherSettings:GetWidth() / 2, self.recent_kills_checkbox:GetTop() + 27)
	self.otherSettings:SetForeColor(default_font_color)
	self.otherSettings:SetFont(Turbine.UI.Lotro.Font.TrajanPro18)
	self.otherSettings:SetFontStyle(Turbine.UI.FontStyle.Outline)
	self.otherSettings:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.otherSettings:SetText(L.Options_Other_Settings)

	self.reset_time = Turbine.UI.Label()
	self.reset_time:SetText(L.Options_Daily_Reset_Time)
	self.reset_time:SetParent(self)
	self.reset_time:SetSize(width - 40, 16)
	self.reset_time:SetPosition(width / 2 - self.reset_time:GetWidth() / 2, self.otherSettings:GetTop() + 25)
	self.reset_time:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.reset_time:SetForeColor(default_font_color)
	self.reset_time:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)

	self.reset_time_time = Turbine.UI.Label()
	self.reset_time_time:SetParent(self)
	self.reset_time_time:SetSize(35, 20)
	self.reset_time_time:SetPosition(width / 2 - 25, self.otherSettings:GetTop() + 23)
	self.reset_time_time:SetForeColor(default_font_color)
	self.reset_time_time:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
	self.reset_time_time:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.reset_time_time:SetText(data.numbers.resettime .. ":00")

	self.reset_time_plus = Turbine.UI.Button()
	self.reset_time_plus:SetParent(self)
	self.reset_time_plus:SetSize(10, 10)
	self.reset_time_plus:SetPosition(
		self.reset_time_time:GetLeft() + self.reset_time_time:GetWidth(),
		self.reset_time_time:GetTop()
	)
	self.reset_time_plus:SetForeColor(default_font_color)
	self.reset_time_plus:SetFont(Turbine.UI.Lotro.Font.Verdana10)
	self.reset_time_plus:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.reset_time_plus:SetText("+")
	self.reset_time_plus.MouseDown = function()
		local time_value = tonumber(string.match(self.reset_time_time:GetText(), "(%d+):00"))
		local new_value = time_value + 1
		if new_value == 24 then
			new_value = 0
		end
		data.numbers.resettime = new_value
		self.reset_time_time:SetText(new_value .. ":00")
	end

	self.reset_time_minus = Turbine.UI.Button()
	self.reset_time_minus:SetParent(self)
	self.reset_time_minus:SetSize(10, 10)
	self.reset_time_minus:SetPosition(
		self.reset_time_time:GetLeft() + self.reset_time_time:GetWidth(),
		self.reset_time_time:GetTop() + 10
	)
	self.reset_time_minus:SetForeColor(default_font_color)
	self.reset_time_minus:SetFont(Turbine.UI.Lotro.Font.Verdana10)
	self.reset_time_minus:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.reset_time_minus:SetText("-")
	self.reset_time_minus.MouseDown = function()
		local time_value = tonumber(string.match(self.reset_time_time:GetText(), "(%d+):00"))
		local new_value = time_value - 1
		if new_value == -1 then
			new_value = 23
		end
		data.numbers.resettime = new_value
		self.reset_time_time:SetText(new_value .. ":00")
	end

	self.slider_label = Turbine.UI.Label()
	self.slider_label:SetText(L.Options_Window_Size)
	self.slider_label:SetParent(self)
	self.slider_label:SetSize(width, 30)
	self.slider_label:SetPosition(width / 2 - self.slider_label:GetWidth() / 2 + 20, self.reset_time:GetTop() + 15)
	self.slider_label:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	self.slider_label:SetForeColor(default_font_color)
	self.slider_label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)

	self.slider_bar = Turbine.UI.Label()
	self.slider_bar:SetParent(self)
	self.slider_bar:SetSize(175, 15)
	self.slider_bar:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
	self.slider_bar:SetBackground("PvMP_Plus/Resources/slider_bar.tga")
	self.slider_bar:SetPosition(width / 2 - 20, self.reset_time:GetTop() + 22)
	self.slider_bar.MouseDown = function(sender, args)
		local newLeft = args.X + width / 2 + 20 - self.slider:GetWidth() / 2
		if newLeft < width / 2 - 20 then
			newLeft = width / 2 - 20
		end
		if newLeft > width / 2 + 139 then
			newLeft = width / 2 + 139
		end
		self.slider:SetPosition(newLeft, self.slider:GetTop())
		data.numbers.overview_width_ratio = (newLeft + 20 - width / 2) / (self.slider_bar:GetWidth() - self.slider:GetWidth())
		OverviewWindow:UpdatePosition()
	end

	self.slider = Turbine.UI.Control()
	self.slider:SetParent(self)
	self.slider:SetSize(16, 16)
	self.slider:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
	self.slider:SetBackground(0x41007e0c)
	self.slider:SetPosition(
		width / 2 - 20 + data.numbers.overview_width_ratio * (self.slider_bar:GetWidth() - self.slider:GetWidth()),
		self.reset_time:GetTop() + 22
	)

	self.slider.MouseDown = function(sender, args)
		self.MoveX = args.X
		self.MoveY = args.Y
		self.sliding = true
	end

	self.slider.MouseUp = function(sender, args)
		self.sliding = false
	end

	self.slider.MouseMove = function(sender, args)
		if self.sliding then
			local newLeft = self.slider:GetLeft() - (self.MoveX - args.X)
			if newLeft < width / 2 - 20 then
				newLeft = width / 2 - 20
			end
			if newLeft > width / 2 + 139 then
				newLeft = width / 2 + 139
			end
			self.slider:SetPosition(newLeft, self.slider:GetTop())
			data.numbers.overview_width_ratio =
				(newLeft + 20 - width / 2) / (self.slider_bar:GetWidth() - self.slider:GetWidth())
			OverviewWindow:UpdatePosition()
		end
	end

	-- Reset Settings
	self.reset_button = Turbine.UI.Lotro.Button()
	self.reset_button:SetText(L.Options_Reset)
	self.reset_button:SetWidth(width - 40)
	self.reset_button:SetPosition(width / 2 - self.reset_button:GetWidth() / 2, self.slider_label:GetTop() + 40)
	self.reset_button:SetParent(self)

	self.battletask_warning_checkbox.CheckedChanged = function()
		storage.battletask_warning_disabled = not storage.battletask_warning_disabled
	end

	self.comms_warning_checkbox.CheckedChanged = function()
		storage.comms_warning_disabled = not storage.comms_warning_disabled
	end

	self.show_stats_checkbox.CheckedChanged = function()
		OverviewWindow:ToggleStatsVisibility()
	end

	self.track_warning_checkbox.CheckedChanged = function()
		storage.track_warning_disabled = not storage.track_warning_disabled
	end

	self.lootbox_alert_checkbox.CheckedChanged = function()
		storage.lootbox_alert_disabled = not storage.lootbox_alert_disabled
	end

	self.yourfrag_alert_checkbox.CheckedChanged = function()
		storage.yourfrag_alert_disabled = not storage.yourfrag_alert_disabled
	end

	self.stealth_alert_checkbox.CheckedChanged = function()
		storage.stealth_alert_disabled = not storage.stealth_alert_disabled
	end

	self.bonus_checkbox.CheckedChanged = function()
		storage.show_bonus_disabled = not storage.show_bonus_disabled
		OverviewWindow.label_bonus:SetVisible(not storage.show_bonus_disabled)
	end

	self.outpost_checkbox.CheckedChanged = function()
		storage.show_outpost_disabled = not storage.show_outpost_disabled
		OverviewWindow.outpost1:SetVisible(not storage.show_outpost_disabled)
		OverviewWindow.outpost1Text:SetVisible(not storage.show_outpost_disabled)
		OverviewWindow.outpost2:SetVisible(not storage.show_outpost_disabled)
		OverviewWindow.outpost2Text:SetVisible(not storage.show_outpost_disabled)
		OverviewWindow.outpost3:SetVisible(not storage.show_outpost_disabled)
		OverviewWindow.outpost3Text:SetVisible(not storage.show_outpost_disabled)
		OverviewWindow.outpost4:SetVisible(not storage.show_outpost_disabled)
		OverviewWindow.outpost4Text:SetVisible(not storage.show_outpost_disabled)
	end

	self.keep_checkbox.CheckedChanged = function()
		storage.show_keep_disabled = not storage.show_keep_disabled
		OverviewWindow.keeps_panel:SetVisible(not storage.show_keep_disabled)
	end

	self.dof_checkbox.CheckedChanged = function()
		storage.show_dof_disabled = not storage.show_dof_disabled
	end

	self.relic_checkbox.CheckedChanged = function()
		storage.show_relic_disabled = not storage.show_relic_disabled
	end

	self.on_checkbox.CheckedChanged = function()
		storage.show_on_disabled = not storage.show_on_disabled
	end

	self.recent_kills_checkbox.CheckedChanged = function()
		storage.show_recent_kills_disabled = not storage.show_recent_kills_disabled
		SecondaryWindow:ShowRecentKills(not storage.show_recent_kills_disabled)
	end

	self.recent_hits_checkbox.CheckedChanged = function()
		storage.show_recent_hits_disabled = not storage.show_recent_hits_disabled
		HitWindow:SetVisible(not storage.show_recent_hits_disabled)
	end

	self.points_update_button.Click = function()
		InitWindowPoints:Open()
	end

	self.frags_update_button.Click = function()
		InitWindowFrags:Open()
	end

	self.reset_button.Click = function()
		ResetWindow:Open()
	end

	self.KeyDown = function(sender, args)
		if args.Action == Turbine.UI.Lotro.Action.Escape then
			self:SetVisible(false)
		end
	end

	self.PositionChanged = function(sender, args)
		data.numbers.settingsWin_x = self:GetLeft()
		data.numbers.settingsWin_y = self:GetTop()
	end
end

function Settings:Open()
	self:SetVisible(true)
end